/*******************************
 * Multiple include protection
 *******************************/
#ifndef _CACHE_H_
#define _CACHE_H_


/************
 * Includes
 ***********/
#include "types.h"
#include "gui.h"


/***********
 * Defines
 **********/
#define BMP_CACHECNT     3
#define BMP_CACHESIZE  600
#define BMP_CACHE_ERROR_PUT_TO_NONEXISTANT_LOCATION FALSE

#define FONT_CACHECNT   12
#define FONT_CACHESIZE 256
#define FONT_CACHE_ERROR_PUT_TO_NONEXISTANT_LOCATION FALSE

#define TEXT_CACHESIZE 256
#define TEXT_CACHE_ERROR_PUT_TO_NONEXISTANT_LOCATION FALSE

#define DESK_CACHESIZE 0x38400


/**************
 * Prototypes 
 **************/
void       cache_bmp_init();
void       cache_bmp_destroy();
HBITMAP    cache_bmp_get(uint8 cache_id, uint16 cache_idx);
void       cache_bmp_put(uint8 cache_id, uint16 cache_idx, HBITMAP bitmap);


void       cache_font_init();
void       cache_font_destroy();
FONTGLYPH* cache_font_get(uint8 font, uint16 character);
void       cache_font_put(uint8 font, uint16 character, uint16 offset,
					 uint16 baseline, uint16 width, uint16 height, HGLYPH pixmap);


void       cache_text_init();
void       cache_text_destroy();
DATABLOB*  cache_text_get(uint8 cache_id);
void       cache_text_put(uint8 cache_id, void *data, int length);

void       cache_desktop_init();
void       cache_desktop_destroy();
void*      cache_desktop_get(uint32 offset);
void       cache_desktop_put(uint32 offset, void* data);

#endif
